"use strict";

exports.__esModule = true;
exports.useLink = void 0;

var _zmp = require("./zmp");

var useLink = function useLink(props) {
  var handleClick = function handleClick(e) {
    e.preventDefault();
    var options = {};
    var routeProps = props.routeProps,
        reloadCurrent = props.reloadCurrent,
        reloadPrevious = props.reloadPrevious,
        reloadAll = props.reloadAll,
        animate = props.animate,
        ignoreCache = props.ignoreCache,
        transition = props.transition,
        href = props.href,
        link = props.link;

    if (href || link) {
      if (routeProps !== undefined) {
        options.props = routeProps;
      }

      if (reloadCurrent !== undefined) {
        options.reloadCurrent = reloadCurrent;
      }

      if (reloadPrevious !== undefined) {
        options.reloadPrevious = reloadPrevious;
      }

      if (reloadAll !== undefined) {
        options.reloadAll = reloadAll;
      }

      if (animate !== undefined) {
        options.animate = animate;
      }

      if (ignoreCache !== undefined) {
        options.ignoreCache = ignoreCache;
      }

      if (transition !== undefined) {
        options.transition = transition;
      }

      _zmp.zmp.views.current.router.navigate(href || link, options);
    }
  };

  return [handleClick];
};

exports.useLink = useLink;