"use strict";

exports.__esModule = true;
exports.useSmartSelect = void 0;

var _vue = require("vue");

var _zmp = require("./zmp");

var _utils = require("./utils");

var useSmartSelect = function useSmartSelect(props, setInstance, getEl) {
  var zmpSmartSelect;
  (0, _vue.onMounted)(function () {
    (0, _zmp.zmpready)(function () {
      if (props.smartSelect) {
        var ssParams = (0, _utils.extend)({
          el: getEl()
        }, props.smartSelectParams || {});
        zmpSmartSelect = _zmp.zmp.smartSelect.create(ssParams);
        setInstance(zmpSmartSelect);
      }
    });
  });
  (0, _vue.onBeforeUnmount)(function () {
    if (zmpSmartSelect && zmpSmartSelect.destroy) {
      zmpSmartSelect.destroy();
    }

    zmpSmartSelect = null;
    setInstance(zmpSmartSelect);
  });
};

exports.useSmartSelect = useSmartSelect;