export enum FlexLayoutGap {
  gap_1 = 'gap_1',
  gap_2 = 'gap_2',
  gap_3 = 'gap_3',
  gap_4 = 'gap_4',
  gap_5 = 'gap_5',
  gap_6 = 'gap_6',
  gap_7 = 'gap_7',
  gap_8 = 'gap_8',
  gap_9 = 'gap_9',
  gap_10 = 'gap_10',
}

export enum SpacingEnum {
  '0' = '0',
  '1' = '1',
  '2' = '2',
  '3' = '3',
  '4' = '4',
  '5' = '5',
  '6' = '6',
  '7' = '7',
  '8' = '8',
  '9' = '9',
  '10' = '10',
}

export enum SkeletonEffect {
  fade = 'fade',
  pulse = 'pulse',
  wave = 'wave',
  none = 'none',
}

export enum VerticalAlignEnum {
  // The element is aligned with the baseline of the parent. This is default
  'baseline' = 'baseline',
  //The element is aligned with the subscript baseline of the parent
  'sub' = 'sub',
  // The element is aligned with the superscript baseline of the parent
  'super' = 'super',
  //The element is aligned with the top of the tallest element on the line
  'top' = 'top',
  //  The element is aligned with the top of the parent element's font
  'text-top' = 'text-top',
  // The element is placed in the middle of the parent element
  'middle' = 'middle',
  // The element is aligned with the lowest element on the line
  'bottom' = 'bottom',
  // The element is aligned with the bottom of the parent element's font
  'text-bottom' = 'text-bottom',
  // Sets this property to its default value
  'initial' = 'initial',
  // Inherits this property from its parent element
  'inherit' = 'inherit',
}

export enum FlexDirectionEnum {
  'row' = 'row',
  'row-reverse' = 'row-reverse',
  'column' = 'column',
  'column-reverse' = 'column-reverse',
}

export enum JustifyContentEnum {
  'flex-start' = 'flex-start',
  'flex-end' = 'flex-end',
  'center' = 'center',
  'space-between' = 'space-between',
  'space-around' = 'space-around',
  'space-evenly' = 'space-evenly',
  'initial' = 'initial',
}

export enum AlignItemsEnum {
  'flex-start' = 'flex-start',
  'flex-end' = 'flex-end',
  'stretch' = 'stretch',
  'baseline' = 'baseline',
  'center' = 'center',
  'initial' = 'initial',
}

export enum AlignContentEnum {
  'stretch' = 'stretch',
  'center' = 'center',
  'flex-start' = 'flex-start',
  'flex-end' = 'flex-end',
  'space-between' = 'space-between',
  'space-around' = 'space-around',
  'space-evenly' = 'space-evenly',
  'initial' = 'initial',
}

export enum TextAlignEnum {
  'left' = 'left',
  'right' = 'right',
  'center' = 'center',
  'justify' = 'justify',
  'initial' = 'initital',
  'inherit' = 'inherit',
}
