
import { ComponentOptionsMixin, DefineComponent, PropType } from 'vue';


declare const ListInput: DefineComponent<
  {
    
    media: {
      type: PropType<string>;
    },

    name: {
      type: PropType<string>;
    },

    inputmode: {
      type: PropType<string>;
    },

    readonly: {
      type: PropType<boolean>;
    },

    required: {
      type: PropType<boolean>;
    },

    disabled: {
      type: PropType<boolean>;
    },

    placeholder: {
      type: PropType<string>;
    },

    inputId: {
      type: PropType<string | number>;
    },

    size: {
      type: PropType<string | number>;
    },

    accept: {
      type: PropType<string | number>;
    },

    autocomplete: {
      type: PropType<string>;
    },

    autocorrect: {
      type: PropType<string>;
    },

    autocapitalize: {
      type: PropType<string>;
    },

    spellcheck: {
      type: PropType<string>;
    },

    autofocus: {
      type: PropType<boolean>;
    },

    autosave: {
      type: PropType<string>;
    },

    max: {
      type: PropType<string | number>;
    },

    min: {
      type: PropType<string | number>;
    },

    step: {
      type: PropType<string | number>;
    },

    maxlength: {
      type: PropType<string | number>;
    },

    minlength: {
      type: PropType<string | number>;
    },

    multiple: {
      type: PropType<boolean>;
    },

    inputStyle: {
      type: PropType<string | object>;
    },

    pattern: {
      type: PropType<string>;
    },

    validate: {
      type: PropType<boolean | string>;
    },

    validateOnBlur: {
      type: PropType<boolean>;
    },

    onValidate: {
      type: PropType<function>;
    },

    tabindex: {
      type: PropType<string | number>;
    },

    resizable: {
      type: PropType<boolean>;
    },

    clearButton: {
      type: PropType<boolean>;
    },

    noFormStoreData: {
      type: PropType<boolean>;
    },

    noStoreData: {
      type: PropType<boolean>;
    },

    ignoreStoreData: {
      type: PropType<boolean>;
    },

    errorMessage: {
      type: PropType<string>;
    },

    errorMessageForce: {
      type: PropType<boolean>;
    },

    info: {
      type: PropType<string>;
    },

    outline: {
      type: PropType<boolean>;
    },

    label: {
      type: PropType<string | number>;
    },

    inlineLabel: {
      type: PropType<boolean>;
    },

    floatingLabel: {
      type: PropType<boolean>;
    },

    calendarParams: {
      type: PropType<object>;
    },

    colorPickerParams: {
      type: PropType<object>;
    },

    textEditorParams: {
      type: PropType<object>;
    },

    sortable: {
      type: PropType<boolean>;
      default: undefined;
    },

    dropdown: {
      type: PropType<string | boolean>;
      default: string;
    },

    wrap: {
      type: PropType<boolean>;
      default: boolean;
    },

    input: {
      type: PropType<boolean>;
      default: boolean;
    },

    type: {
      type: PropType<string>;
      default: string;
    },

    value: {
      type: PropType<string | number | any[] | any | object>;
      default: undefined;
    },

    color: {
      type: PropType<string>;
    },

    colorTheme: {
      type: PropType<string>;
    },

    textColor: {
      type: PropType<string>;
    },

    bgColor: {
      type: PropType<string>;
    },

    borderColor: {
      type: PropType<string>;
    },

    rippleColor: {
      type: PropType<string>;
    },

    themeDark: {
      type: PropType<boolean>;
    }
  },
  () => JSX.Element,
  unknown,
  {},
  {},
  ComponentOptionsMixin,
  ComponentOptionsMixin,
  ("textarea:resize" | "input:notempty" | "input:empty" | "input:clear" | "texteditor:change" | "calendar:change" | "colorpicker:change" | "change" | "focus" | "blur" | "input" | "update:value")[],
  "textarea:resize" | "input:notempty" | "input:empty" | "input:clear" | "texteditor:change" | "calendar:change" | "colorpicker:change" | "change" | "focus" | "blur" | "input" | "update:value"
>;

export default ListInput;
  