
import { ComponentOptionsMixin, DefineComponent, PropType } from 'vue';


declare const Page: DefineComponent<
  {
    
    name: {
      type: PropType<string>;
    },

    stacked: {
      type: PropType<boolean>;
    },

    noNavbar: {
      type: PropType<boolean>;
    },

    noToolbar: {
      type: PropType<boolean>;
    },

    tabs: {
      type: PropType<boolean>;
    },

    noSwipeback: {
      type: PropType<boolean>;
    },

    ptr: {
      type: PropType<boolean>;
    },

    ptrDistance: {
      type: PropType<number>;
    },

    ptrBottom: {
      type: PropType<boolean>;
    },

    ptrMousewheel: {
      type: PropType<boolean>;
    },

    infinite: {
      type: PropType<boolean>;
    },

    infiniteTop: {
      type: PropType<boolean>;
    },

    infiniteDistance: {
      type: PropType<number>;
    },

    hideBarsOnScroll: {
      type: PropType<boolean>;
    },

    hideNavbarOnScroll: {
      type: PropType<boolean>;
    },

    hideToolbarOnScroll: {
      type: PropType<boolean>;
    },

    messagesContent: {
      type: PropType<boolean>;
    },

    loginScreen: {
      type: PropType<boolean>;
    },

    withSubnavbar: {
      type: PropType<boolean>;
      default: undefined;
    },

    subnavbar: {
      type: PropType<boolean>;
      default: undefined;
    },

    withNavbarLarge: {
      type: PropType<boolean>;
      default: undefined;
    },

    navbarLarge: {
      type: PropType<boolean>;
      default: undefined;
    },

    pageContent: {
      type: PropType<boolean>;
      default: boolean;
    },

    ptrPreloader: {
      type: PropType<boolean>;
      default: boolean;
    },

    infinitePreloader: {
      type: PropType<boolean>;
      default: boolean;
    },

    color: {
      type: PropType<string>;
    },

    colorTheme: {
      type: PropType<string>;
    },

    textColor: {
      type: PropType<string>;
    },

    bgColor: {
      type: PropType<string>;
    },

    borderColor: {
      type: PropType<string>;
    },

    rippleColor: {
      type: PropType<string>;
    },

    themeDark: {
      type: PropType<boolean>;
    }
  },
  () => JSX.Element,
  unknown,
  {},
  {},
  ComponentOptionsMixin,
  ComponentOptionsMixin,
  ("page:mounted" | "page:init" | "page:reinit" | "page:beforein" | "page:beforeout" | "page:afterout" | "page:afterin" | "page:beforeremove" | "page:beforeunmount" | "page:tabshow" | "page:tabhide" | "ptr:pullstart" | "ptr:pullmove" | "ptr:pullend" | "ptr:refresh" | "ptr:done" | "infinite")[],
  "page:mounted" | "page:init" | "page:reinit" | "page:beforein" | "page:beforeout" | "page:afterout" | "page:afterin" | "page:beforeremove" | "page:beforeunmount" | "page:tabshow" | "page:tabhide" | "ptr:pullstart" | "ptr:pullmove" | "ptr:pullend" | "ptr:refresh" | "ptr:done" | "infinite"
>;

export default Page;
  