
import { ComponentOptionsMixin, DefineComponent, PropType } from 'vue';


declare const Range: DefineComponent<
  {
    
    formatLabel: {
      type: PropType<function>;
    },

    formatScaleLabel: {
      type: PropType<function>;
    },

    name: {
      type: PropType<string>;
    },

    input: {
      type: PropType<boolean>;
    },

    inputId: {
      type: PropType<string>;
    },

    disabled: {
      type: PropType<boolean>;
    },

    init: {
      type: PropType<boolean>;
      default: boolean;
    },

    value: {
      type: PropType<number | any[] | string>;
      default: number;
    },

    min: {
      type: PropType<number | string>;
      default: number;
    },

    max: {
      type: PropType<number | string>;
      default: number;
    },

    step: {
      type: PropType<number | string>;
      default: number;
    },

    label: {
      type: PropType<boolean>;
      default: boolean;
    },

    dual: {
      type: PropType<boolean>;
      default: boolean;
    },

    vertical: {
      type: PropType<boolean>;
      default: boolean;
    },

    verticalReversed: {
      type: PropType<boolean>;
      default: boolean;
    },

    draggableBar: {
      type: PropType<boolean>;
      default: boolean;
    },

    scale: {
      type: PropType<boolean>;
      default: boolean;
    },

    scaleSteps: {
      type: PropType<number>;
      default: number;
    },

    scaleSubSteps: {
      type: PropType<number>;
      default: number;
    },

    limitKnobPosition: {
      type: PropType<boolean>;
      default: undefined;
    },

    color: {
      type: PropType<string>;
    },

    colorTheme: {
      type: PropType<string>;
    },

    textColor: {
      type: PropType<string>;
    },

    bgColor: {
      type: PropType<string>;
    },

    borderColor: {
      type: PropType<string>;
    },

    rippleColor: {
      type: PropType<string>;
    },

    themeDark: {
      type: PropType<boolean>;
    }
  },
  () => JSX.Element,
  unknown,
  {},
  {},
  ComponentOptionsMixin,
  ComponentOptionsMixin,
  ("range:change" | "range:changed" | "rangeChange" | "rangeChanged" | "update:value")[],
  "range:change" | "range:changed" | "rangeChange" | "rangeChanged" | "update:value"
>;

export default Range;
  